Jakarta Validation TCK Changelog
================================

See also https://hibernate.atlassian.net/projects/BVTCK/issues

3.1.1 (04-06-2024)
------------------------
* Adding lib jars to the web archive in TCK may result in an error if the path to
the jar has escapable symbols
** https://github.com/jakartaee/validation-spec/issues/284

3.1.0 (27-03-2024)
------------------------
** Renamed Jakarta Bean Validation to Jakarta Validation
** Added basic tests for Java Records
** Updated version dependencies for Jakarta EE 11
*** Jakarta Validation 3.1.0
*** Jakarta CDI 4.1.0
*** Jakarta EL 6.0.0
*** Jakarta Interceptors 2.2.0
*** Jakarta Annotations 3.0.0
*** Arquillian 1.8.0.Final

3.0.0 (21-09-2020)
------------------------
** Changes; updated to support the change in the EE API package from javax.* to jakarta.*

2.0.3.Final (30-04-2018)
------------------------

** Bug
    * [BVTCK-204] - TCK method inheritance setups violation specification
    * [BVTCK-203] - Copy/paste error in InvalidConstraintDefinitionsTest
    * [BVTCK-202] - Apparent TCK misuse of ValidationTarget.PARAMETERS
    * [BVTCK-201] - Incompatible value submitted to Validator#validateValue()
    * [BVTCK-200] - Invalid validationAppliesTo value for @CustomComposingConstraint
    * [BVTCK-199] - Do not use the @Size constraint on an int
    * [BVTCK-198] - Test BootstrapConfigurationWithValidatedExecutableTypesContainingNONETest is incorrect
    * [BVTCK-197] - Fix mismatch between registered constraint and defined constraint for a few constraint validators
    * [BVTCK-196] - Fix two ConstraintCompositionTest tests using an invalid parameter values object
    * [BVTCK-192] - ArchiveBuilder uses the internal ShrinkWrap URLPackageScanner API

** Improvement
    * [BVTCK-205] - Improve consistency of InvalidGroupConversionInPropertyLevelOverridingTest
    * [BVTCK-193] - Exclude the Maven wrapper directory from the license check

** Task
    * [BVTCK-195] - Remove test from the TCK which relates to undefined spec behavior

2.0.2.Final (29-01-2018)
------------------------

** Bug
    * [BVTCK-191] - TCK does not run on Windows due to path issues
    * [BVTCK-190] - A few deployment archives are missing classes

** Improvement
    * [BVTCK-188] - Allow invalid validation.xml errors to be thrown at deployment time
    * [BVTCK-74] - Make ArchiveClassLoader work with JDK 9

** Task
    * [BVTCK-189] - Disable the JavaFX tests by default and provide an option to enable them

2.0.1.Final (20-12-2017)
------------------------

** Bug
    * [BVTCK-186] - Fix invalid constraint validator declarations

** Task
    * [BVTCK-187] - Upgrade referenced version of Hibernate Validator to 6.0.7.Final
    * [BVTCK-185] - Upgrade Bean Validation API to 2.0.1.Final

2.0.0.Final (03-08-2017)
------------------------

** Bug
    * [BVTCK-183] - Fix wrong test around value extractors for inheritance hierarchies

** Task
    * [BVTCK-184] - Upgrade to Bean Validation 2.0.0.Final and HV 6.0.0.Final

2.0.0.CR3 (11-07-2017)
----------------------

** Improvement
    * [BVTCK-181] - Fix 2 typos in test method names
    * [BVTCK-180] - Add CONTRIBUTING.md file
    * [BVTCK-179] - Add tests for ConstraintViolationAssert
    * [BVTCK-177] - Create test war files more efficiently

** Task
    * [BVTCK-182] - Upgrade to Bean Validation 2.0.0.CR3 and HV 6.0.0.CR3
    * [BVTCK-176] - Add tests for getLeafBean on container element constraint violations

2.0.0.CR2 (05-07-2017)
----------------------

** Improvement
    * [BVTCK-172] - Use the full URLs in xsi:schemaLocation of our XML files

** Task
    * [BVTCK-175] - Update the BV API and HV to CR2
    * [BVTCK-174] - from of @ConvertGroup and <convert-group /> now has a default value
    * [BVTCK-173] - Take into account API changes introduced as part of BVAL-674
    * [BVTCK-171] - Add tests for getInvalidValue() for container element constraints
    * [BVTCK-162] - Add test for Section 10 - Exception model - a - exception wrapping

2.0.0.CR1 (29-06-2017)
----------------------

** Improvement
    * [BVTCK-165] - Test with WrapperWithDisabledUnwrapping should be based on presence of violation
    * [BVTCK-156] - Improvements to the new containsOnlyViolations() testing API
    * [BVTCK-127] - Use containsExactlyInAnyOrder instead of containsOnly for containsOnlyPaths
    * [BVTCK-79] - Update the references to Java EE 7 and Glassfish 4 in the documentation
    * [BVTCK-78] - Update setup examples for TCK 2.0.0

** New Feature
    * [BVTCK-120] - Add more tests for container element constraints metadata support
    * [BVTCK-119] - Add tests for the XML support of group conversion for container element types

** Task
    * [BVTCK-170] - Add tests for nested container element traversing
    * [BVTCK-169] - Add test for 7.11 b)
    * [BVTCK-168] - Add more tests for implicit unwrapping value extractor resolution algorithm
    * [BVTCK-167] - Metadata adjustments following BVAL-655
    * [BVTCK-166] - Add a test for the legacy behavior of @Valid on arrays
    * [BVTCK-164] - Add tests for @PastOrPresent and @FutureOrPresent
    * [BVTCK-163] - Add tests for ContainerElementDescriptor#getElementClass()
    * [BVTCK-161] - Add tests for @PositiveOrZero and @NegativeOrZero
    * [BVTCK-159] - Add more tests regarding new style container cascading
    * [BVTCK-158] - Add a test for cascading validation with 2 inner extractions
    * [BVTCK-155] - Add a test for @OverridesAttribute default name()
    * [BVTCK-154] - Update tck-audit.xml after BVAL-616, BVAL-624 and BVAL-646
    * [BVTCK-153] - Add tests for injection of value extractors loaded by the service loader
    * [BVTCK-152] - Add tests for "ValueExtractor resolution algorithm for container element constraints"
    * [BVTCK-151] - Add test for ValueExtractorDeclarationException
    * [BVTCK-150] - Add tests for XML declaration of container element constraints and cascading
    * [BVTCK-149] - Add test for ConstraintDescriptor#validateUnwrappedValue() and Skip/Unwrap behavior
    * [BVTCK-148] - Add test for validation.xml's value-extractor element
    * [BVTCK-147] - Add test for Configuration#addValueExtractor()
    * [BVTCK-146] - Add test for PropertyPathTest and container element information in Section 6.2 - ConstraintViolation
    * [BVTCK-145] - Add tests for "ValueExtractor resolution algorithm for constraints on non-generic containers"
    * [BVTCK-144] - Add tests for "ValueExtractor resolution algorithm for cascaded validation"
    * [BVTCK-143] - Add tests for "ConstraintValidator resolution algorithm"
    * [BVTCK-142] - Add tests for value extractors registration
    * [BVTCK-141] - Fix an assertion reference in ValidatorResolutionTest
    * [BVTCK-140] - Make available the CollectionHelper class from HV
    * [BVTCK-139] - Add test to validate that the value extractor is not called for a null container
    * [BVTCK-138] - Add tests for group conversions on container elements
    * [BVTCK-137] - Add tests for validation of container elements constraints
    * [BVTCK-136] - Add tests for cascading validation on container elements
    * [BVTCK-135] - Create a script to increment assertion ids when one assertion is inserted
    * [BVTCK-134] - Clarify that JavaFX is required for running and passing the TCK
    * [BVTCK-133] - Add a test utility to assert violation properties in a consistent manner
    * [BVTCK-132] - Add tests for section 4 - Value extractor definition
    * [BVTCK-131] - Clarify what we should do about EmailConstraintTest
    * [BVTCK-130] - Add tests for invalid group conversion configuration with container elements
    * [BVTCK-129] - Update tck-audit.xml and assertion references after BVAL-618
    * [BVTCK-123] - Add tests for non getter method and constructor for 5.7.4 - d
    * [BVTCK-122] - Add a test checking that value() is called even if Optional does not have any value (same for Optional* primitive wrappers)

2.0.0.Beta2 (24-05-2017)
------------------------

** Improvement
    * [BVTCK-121] - Rework the test hierarchy and improve the consistency between HV test infrastructure and the TCK

** Task
    * [BVTCK-126] - Add tests for the container element related methods of the node builder API
    * [BVTCK-125] - Test that ValueExtractors defined in XML are CDI enabled
    * [BVTCK-124] - Update TCK audit file to BV 2.0.0.Beta2

2.0.0.Beta1 (11-05-2017)
------------------------

** Improvement
    * [BVTCK-111] - Dynamically generate the current copyright year

** New Feature
    * [BVTCK-116] - Add tests for container element constraints metadata support
    * [BVTCK-114] - Add tests for the support of group conversion for container element types

** Task
    * [BVTCK-118] - Upgrade referenced version of HV to 6.0.0.Beta1
    * [BVTCK-112] - Update the tck-audit.xml file and assertion id references to BV 2.0.0.Beta1
    * [BVTCK-62] - Investigate how signature files could be created as part of the build

2.0.0.Alpha3 (30-03-2017)
-------------------------

** Improvement
    * BVTCK-110 Fix constraint tests added as part as BVTCK-107

2.0.0.Alpha2 (30-03-2017)
-------------------------

** Bug
    * BVTCK-95 Fix tests failing in container environment
    * BVTCK-57 Avoid the use of @BeforeMethod

** Improvement
    * BVTCK-106 Switch assertion section ids to a string instead of a numeric representation
    * BVTCK-105 Add properties so that test urls can be available in coverage report
    * BVTCK-104 Update jboss-test-audit to 1.1.2.Final
    * BVTCK-103 Test that invalid XML configuration files throw ValidationException
    * BVTCK-102 Add some more XML versioning tests for BV 2.0
    * BVTCK-101 Fix interverted assertion reference in XML versioning tests
    * BVTCK-96 Use ConstraintDescriptor.getMessageTemplate() instead of relying on the attributes

** New Feature
    * BVTCK-107 Test new spec constraints @NotEmpty, @NotBlank, @Email, @Positive, @Negative

** Task
    * BVTCK-109 Update to validation-api 2.0.0.Alpha2 and HV 6.0.0.Alpha2
    * BVTCK-108 Add tests for all array of primitives cases for @Size
    * BVTCK-100 BVAL-496 Update the assertion references and add tests for new java.time support
    * BVTCK-99 3.4.1 Test the default ClockProvider present in the ConstraintValidatorContext
    * BVTCK-98 Update 3.4 with the addition of the default initialize() method to ConstraintValidator
    * BVTCK-97 Update the constraint composition tests
    * BVTCK-92 Use shorter license header for TCK tests
    * BVTCK-90 bean-validation-tck-tests has JSR 250 API twice in the classpath
    * BVTCK-82 Convert TCK docs to AsciiDoc

2.0.0.Alpha1 (15-02-2017)
-------------------------

** Bug
    * BVTCK-73 Expected and actual value switched in MessageInterpolationTest.testRecursiveMessageInterpolation()

** Improvement
    * BVTCK-87 Test @Repeatable annotations
    * BVTCK-86 Clean up the settings-example.xml file
    * BVTCK-85 Set the version of the maven-deploy-plugin
    * BVTCK-84 Use the shrinkwrap version coming with Arquillian instead of overriding it
    * BVTCK-80 Update the link to download the TCK from the BV website
    * BVTCK-77 Bump JSR version and project version
    * BVTCK-76 Re-create tck-audit.xml after AsciiDoc conversion
    * BVTCK-75 Update tck-audit.xml

** Task
    * BVTCK-94 Update links to BV and our issue tracker
    * BVTCK-93 Clean up the empty initialize methods of the ConstraintValidators
    * BVTCK-91 Base the TCK on BV 2.0.0.Alpha1
    * BVTCK-89 Include tests for BVAL-496 (java.time support) in the TCK
    * BVTCK-88 Take into account BVAL-498 - Parameter names
    * BVTCK-83 Update the test headers to BV 2.0
    * BVTCK-81 Publish the doc for 2.0.0-SNAPSHOT and update the related links

1.1.4.Final (18-06-2015)
------------------------

** Bug
    * [BVTCK-68] - Remove UnknownVersionInValidationXmlTest and InvalidXmlConfigurationTest


1.1.3.Final (18-06-2014)
------------------------

** Task
    * [BVTCK-66] - Create signature file for Java 8


1.0.7.GA (18-06-2014)
---------------------

** Task
    * [BVTCK-66] - Create signature file for Java 8


1.1.2.Final (29-11-2013)
------------------------

** Bug
    * [BVTCK-44] - Make ArtifactDumper work with "mvn install"
    * [BVTCK-64] - Fix tests which pass wrong-sized argument arrays to validateParameters()

** Improvement
    * [BVTCK-53] - Improve layout of reference guide PDF title page
    * [BVTCK-59] - Update dependencies


1.1.1.Final (24-04-2013)
------------------------

** Task
    * [BVTCK-61] - Update signature files due to removal of @Deprecated annotations


1.1.0.Final (10-04-2013)
------------------------

** Bug
    * [BVTCK-56] - Set version attribute for web.xml descriptors

** Improvement
    * [BVTCK-55] - Update audit file due to re-ordered assertions in XML chapter
    * [BVTCK-58] - Update version of BV API dependency to 1.1.0.Final

** Task
    * [BVTCK-23] - Finalize TCK documentation


1.1.0.CR5 (02-04-2013)
----------------------

** Improvement
    * [BVTCK-54] - Use qualifiers for producer methods in CDI tests


1.1.0.CR4 (20-03-2013)
----------------------

** Bug
    * [BVTCK-35] - Improve TCK packaging for people unfamiliar with the technologies used
    * [BVTCK-37] - Improvements around TCK documentation
    * [BVTCK-40] - Determine whether a cross parameter constraint can be applied on a paramterless method/constructor
    * [BVTCK-41] - Integrate the maven and ant setup example in the docbook documentation
    * [BVTCK-50] - Use EJB 3.1 API as build-time dependency to avoid language level warnings
    * [BVTCK-51] - Update signature tests

** Improvement
    * [BVTCK-52] - Include integration tests by default

** Task
    * [BVTCK-47] - Update assertions marked with "needs update"
    * [BVTCK-48] - Create and map test assertions for Bean Validation 1.1
    * [BVTCK-49] - Assign or remove unassigned TCK tests


1.1.0.CR3 (15-03-2013)
----------------------

** Task
    * [BVTCK-45] - Create and map test assertions for Bean Validation 1.1


1.1.0.CR2 (08-03-2013)
----------------------

** Improvement
    * [BVTCK-42] - Create and map tests for BV 1.1 assertions


1.1.0.CR1 (21-02-2013)
------------------------

** Bug
    * [BVTCK-11] - Wrong usage of context classloader to discover resources in META-INF/services

** New Feature
    * [BVTCK-39] - Implement/update TCK tests after 1.1.0.Beta3

** Task
    * [BVTCK-30] - Provide exemplary settings.xml
    * [BVTCK-33] - Provide minimal TCK setup example in TCK docs


1.1.0.Beta3 (06-02-2013)
------------------------

** Bug
    * [BVTCK-36] - Update UnknownProviderBootstrapTest to request an explicit provider

** Improvement
    * [BVTCK-27] - Do not append assembly id when creating the distribution bundle

** New Feature
    * [BVTCK-28] - Update TCK to match chapters/sections as of BV 1.1

** Task
    * [BVTCK-31] - Add assertions for BV 1.1 functionality
    * [BVTCK-32] - Implement TCK tests for new BV 1.1 functionality


1.1.0.Beta2 (29-11-2012)
------------------------

** Task
    * [BVTCK-26] - Upgrade to Beta Validation API 1.1.0.Beta2


1.1.0.Beta1 (09-11-2012)
------------------------

** Bug
    * [BVTCK-22] - Update the TCK documentation
    * [BVTCK-24] - Upload TCK docs to JBoss docs server
    * [BVTCK-25] - Align TCK with latest Bean Validation API

** Task
    * [BVTCK-10] - Move the test framework to Arquillian


1.0.6.GA (26-07-2011)
----------------------

** Bug
    * [BVTCK-20] - TCK needs a sig file recorded with Java SE 7


1.0.5.GA (15-06-2011)
----------------------

** Improvement
    * [BVTCK-19] - Move license text to license.txt

** Task
    * [BVTCK-17] - Update documentation


1.0.5.Beta1 (07-01-2011)
------------------------

** Bug
    * [BVTCK-12] - The TCK goes against the spec on Node and nested Path: section 4.2
    * [BVTCK-14] - ValidateTest.testValidatedPropertyDoesNotFollowJavaBeansConvention expects wrongly an exception to be thrown for a constraint placed on a non getter method
    * [BVTCK-16] - Change documentation to reference Github insteadof SVN as source reference
    * [BVTCK-18] - Update scm information in pom.xml to reflect move to github

** Improvement
    * [BVTCK-15] - Update dependencies in pom


1.0.4.GA (20-09-2010)
----------------------

** Bug
    * [BVTCK-7] - Update all tests within a package to use the same resource includes via @Classes

** Task
    * [BVTCK-6] - Update pom to use the new distributationManagement information
    * [BVTCK-8] - Update dependencies in pom
    * [BVTCK-9] - Update docbook documentation


1.0.3.GA (25-11-2009)
----------------------

** Task
    * [BVTCK-5] - Provide separate signature files for Java 5 and  Java 6
    

1.0.2.GA (24-11-2009)
----------------------

** Task
    * [BVTCK-3] - Create release notes for the distribution package
    * [BVTCK-4] - Add signature test file to TCK distribution package 


1.0.1.GA (28-10-2009)
----------------------

** Bug
    * [BVTCK-1] - Make sure that validateValue and validateProperty tests only use single value properties

** Task
    * [BVTCK-2] - Move testcase for HV-253 into the TCK

